.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include uFMOD_Ds.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax

    invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DIALOG,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

;########################################################################

DlgProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	.if uMsg==WM_INITDIALOG
	       invoke StatusTime,hWnd,0,0,0
              mov XmResID,500
              mov szPauseId,TRUE
              inc szXmCount
           invoke SongCounter ,hWnd
         
        ;Vu Meter
       mov bmp.bmiHeader.biSize, sizeof bmp.bmiHeader
        mov bmp.bmiHeader.biWidth, VIS_WIDTH
        mov bmp.bmiHeader.biHeight, -VIS_HEIGHT
        mov bmp.bmiHeader.biPlanes, 1
        mov bmp.bmiHeader.biBitCount, 8
        mov bmp.bmiHeader.biClrUsed, VIS_WIDTH+1
        mov bmp.bmiHeader.biClrImportant, VIS_WIDTH+1
        invoke GetSysColor,COLOR_BTNFACE
        mov bmp.bmiColors, eax                   ; change from RGB to BGR
        mov cl, bmp.bmiColors.rgbRed
        mov bmp.bmiColors.rgbBlue, cl
        mov bmp.bmiColors.rgbRed, al
        mov eax, 1
        mov ebx, 255
        .while eax <= VIS_WIDTH ; create pallete
         mov bmp.bmiColors[eax*sizeof bmp.bmiColors].rgbRed, 208
         mov bmp.bmiColors[eax*sizeof bmp.bmiColors].rgbGreen,47
         mov bmp.bmiColors[eax*sizeof bmp.bmiColors].rgbBlue, 123
         sub ebx, 2
         inc eax
        .endw
        invoke CreateDIBSection, 0, ADDR bmp, DIB_RGB_COLORS, ADDR specbuf, NULL, 0
        mov specbmp, eax
        invoke CreateCompatibleDC, 0
        mov specdc, eax
        invoke SelectObject, specdc, specbmp

        push hWnd
        pop  hWinLevel
        invoke timeSetEvent, 25, 25, ADDR Level, 0, TIME_PERIODIC
        mov timer, eax
        
        
	.elseif uMsg==WM_COMMAND
         .if wParam ==IDC_PLAY 
             .if szPauseId==TRUE
				   invoke uFMOD_DsPlayRes,hWnd,XmResID,TRUE 
         	       invoke Get_TitleSong,hWnd
         	 @timer:
                   invoke SetTimer, hWnd, ID_TIMER1,1,offset CalcElapsedTime	
			.else
				   invoke uFMOD_Resume
					  mov szPauseId, TRUE
			.endif

           .elseif wParam ==IDC_STOP
                   invoke uFMOD_DsPlayRes,hWnd,XmResID,FALSE
               @stop:
                   invoke KillTimer,hWnd,ID_TIMER1 
                   invoke StatusTime,hWnd,0,0,0 
                   
            .elseif wParam ==IDC_BACK 
                       cmp XmResID,500
                        jz @F
                       dec XmResID
                    invoke uFMOD_DsPlayRes,hWnd,XmResID,TRUE 
                    invoke Get_TitleSong,hWnd
                       dec szXmCount
                    invoke SongCounter ,hWnd  
                       jmp @timer
                 @@:

            .elseif wParam ==IDC_FORWARD
                       cmp XmResID,506
                        jz @F
                       inc XmResID
                    invoke uFMOD_DsPlayRes,hWnd,XmResID,TRUE 
                    invoke Get_TitleSong,hWnd
                       inc szXmCount
                    invoke SongCounter ,hWnd
                       jmp @timer
                 @@:

                   invoke  uFMOD_Resume
          .elseif wParam ==IDC_PAUSE
          	  .if szPauseId==TRUE
					invoke uFMOD_Pause
					   mov szPauseId, FALSE
				.else
					invoke  uFMOD_Resume
					   mov  szPauseId, TRUE
			  .endif
         .endif
     
	.elseif uMsg==WM_CLOSE
	 invoke timeKillEvent, timer
	          .if specbmp != NULL 
          invoke DeleteObject, specbmp 
        .endif
        .if specdc != NULL  
          invoke DeleteDC, specdc      
        .endif  
		invoke EndDialog,hWnd,0
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

Get_TitleSong Proc hWnd:DWORD

	invoke uFMOD_GetTitle
	invoke wsprintf, addr hSongTitle , addr szTitleFrm, eax
	invoke SetDlgItemText,hWnd,IDC_SONGTITLE ,addr hSongTitle 
	ret
Get_TitleSong endp

SongCounter proc hWnd:DWORD
	
	invoke wsprintf,addr hCount,addr szSongFrm,szXmCount
	invoke SetDlgItemText,hWnd,IDC_SONGNO,addr hCount
	ret
SongCounter endp

CalcElapsedTime PROC hWnd:DWORD

	invoke uFMOD_GetTime 
	mov ecx,StartTime	                ;Time=EndTime-StartTime
	
	mov StartTime,eax
	sub eax,ecx		                    ;eax=Time

	add eax,ElapsedTime
	xor edx,edx
	mov ElapsedTime,eax	                ;eax=ElapsedTime in miliseconds

	mov ecx,1000*60		                ;convers miliseconds to minutes & seconds
	xor edx,edx
	div ecx			                    ;eax=seconds
	push eax		                    ;eax=minutes, save it

	mov eax,edx		                    ;calc seconds
	mov ecx,1000
	xor edx,edx
	div ecx
	pop ecx			                    ;restore minutes
	invoke StatusTime,hWnd,ecx,eax,edx  ;ecx,eax,edx min:sec:ms
	ret
CalcElapsedTime ENDP

StatusTime PROC hWnd:DWORD,Min:DWORD,Sec:DWORD,Ms:DWORD
	invoke wsprintf,offset szStatusElapsedTime,
		            offset szElapsedTime,Min,Sec,Ms
	invoke SetDlgItemText, hWnd,IDC_TIME, addr szStatusElapsedTime
	ret
StatusTime ENDP

Level proc uses ebx, p1,p2,p3,p4,p5 :DWORD

    LOCAL hDC         :DWORD
    LOCAL buffer1[12] :BYTE

       invoke GetDC, hWinLevel
       mov hDC, eax

       mov ecx, [specbuf]                             ; clear window
       xor ebx, ebx
       .while ebx < VIS_WIDTH * VIS_HEIGHT
         mov BYTE PTR [ebx+ecx], 0
         inc ebx
       .endw
       
       invoke uFMOD_GetStats
       mov ecx, [specbuf]
       .if eax != -1                                  ; error?
        .if ah > VIS_WIDTH                            ; level exceed VIS_WIDTH
          mov ah, VIS_WIDTH 
        .endif 
        xor ebx, ebx
        .while bl < ah                                ; display level
          mov BYTE PTR [ebx+ecx], bl                  ; line 1
          mov BYTE PTR [ebx+ecx+VIS_WIDTH], bl        ; line 2
          mov BYTE PTR [ebx+ecx+VIS_WIDTH*2], bl      ; line 3              
          mov BYTE PTR [ebx+ecx+VIS_WIDTH*3], bl      ; line 4                        
          inc bl        
        .endw
		ror eax,16         ; get right channel
		add ecx,VIS_WIDTH*5
        .if ah > VIS_WIDTH                            ; level exceed VIS_WIDTH
          mov ah, VIS_WIDTH 
        .endif 
        xor ebx, ebx
        .while bl < ah                                ; display level
          mov BYTE PTR [ebx+ecx], bl                  ; line 1
          mov BYTE PTR [ebx+ecx+VIS_WIDTH], bl        ; line 2
          mov BYTE PTR [ebx+ecx+VIS_WIDTH*2], bl      ; line 3              
          mov BYTE PTR [ebx+ecx+VIS_WIDTH*3], bl      ; line 4                        
          inc bl        
        .endw
       .endif 
       invoke BitBlt, hDC, 20,101, VIS_WIDTH,VIS_HEIGHT, specdc, 0, 0, SRCCOPY

       invoke ReleaseDC, hWinLevel, hDC
    ret

Level endp
end start
